"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = undefined;

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _GitUtilities = require("./GitUtilities");

var _GitUtilities2 = _interopRequireDefault(_GitUtilities);

var _FileSystemUtilities = require("./FileSystemUtilities");

var _FileSystemUtilities2 = _interopRequireDefault(_FileSystemUtilities);

var _path = require("path");

var _path2 = _interopRequireDefault(_path);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var Repository = function () {
  function Repository() {
    _classCallCheck(this, Repository);

    this.rootPath = _GitUtilities2.default.getTopLevelDirectory();

    this.lernaJsonLocation = _path2.default.join(this.rootPath, "lerna.json");
    this.packageJsonLocation = _path2.default.join(this.rootPath, "package.json");
    this.versionLocation = _path2.default.join(this.rootPath, "VERSION");

    if (_FileSystemUtilities2.default.existsSync(this.lernaJsonLocation)) {
      this.lernaJson = JSON.parse(_FileSystemUtilities2.default.readFileSync(this.lernaJsonLocation));
    }

    if (_FileSystemUtilities2.default.existsSync(this.packageJsonLocation)) {
      this.packageJson = JSON.parse(_FileSystemUtilities2.default.readFileSync(this.packageJsonLocation));
    }

    this.packagesLocation = _path2.default.join(this.rootPath, "packages");
  }

  _createClass(Repository, [{
    key: "getVersion",
    value: function getVersion() {
      return _FileSystemUtilities2.default.readFileSync(this.versionLocation).toString().trim();
    }
  }]);

  return Repository;
}();

exports.default = Repository;