"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = undefined;

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _FileSystemUtilities = require("../FileSystemUtilities");

var _FileSystemUtilities2 = _interopRequireDefault(_FileSystemUtilities);

var _Command2 = require("../Command");

var _Command3 = _interopRequireDefault(_Command2);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var InitCommand = function (_Command) {
  _inherits(InitCommand, _Command);

  function InitCommand() {
    _classCallCheck(this, InitCommand);

    return _possibleConstructorReturn(this, Object.getPrototypeOf(InitCommand).apply(this, arguments));
  }

  _createClass(InitCommand, [{
    key: "initialize",
    value: function initialize(callback) {
      // Nothing to do...
      callback(null, true);
    }
  }, {
    key: "execute",
    value: function execute(callback) {
      this.ensurePackagesDirectory();
      this.ensurePackageJSON();
      this.ensureVersion();
      this.logger.success("Successfully created Lerna files");
      callback(null, true);
    }
  }, {
    key: "ensurePackagesDirectory",
    value: function ensurePackagesDirectory() {
      var packagesLocation = this.repository.packagesLocation;
      if (!_FileSystemUtilities2.default.existsSync(packagesLocation)) {
        this.logger.info("Creating packages folder.");
        _FileSystemUtilities2.default.mkdirSync(packagesLocation);
      }
    }
  }, {
    key: "ensurePackageJSON",
    value: function ensurePackageJSON() {
      var packagesLocation = this.repository.packageJsonLocation;

      if (!_FileSystemUtilities2.default.existsSync(packagesLocation)) {
        this.logger.info("Creating package.json.");
        _FileSystemUtilities2.default.writeFileSync(packagesLocation, JSON.stringify({
          private: true,
          dependencies: {
            lerna: "^" + this.lernaVersion
          }
        }, null, "  "));
      }
    }
  }, {
    key: "ensureVersion",
    value: function ensureVersion() {
      if (!this.flags.independent) {
        var versionLocation = this.repository.versionLocation;
        if (!_FileSystemUtilities2.default.existsSync(versionLocation)) {
          this.logger.info("Creating VERSION file.");
          _FileSystemUtilities2.default.writeFileSync(versionLocation, "0.0.0");
        }
      }
    }
  }]);

  return InitCommand;
}(_Command3.default);

exports.default = InitCommand;